<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Spatie\Permission\Models\Role;
use Spatie\Permission\Models\Permission;
use App\Models\OtherOne;
use Maatwebsite\Excel\Facades\Excel;
use App\Exports\ExportOtherOne;
use App\Imports\ImportOtherOne;
use Auth, DB, Mail, Validator, File, DataTables, Exception;

class OtherOneController extends Controller{
    /** construct */
        public function __construct(){
            $this->middleware('permission:other_one-create', ['only' => ['create']]);
            $this->middleware('permission:other_one-edit', ['only' => ['edit']]);
            // $this->middleware('permission:other_one-view', ['only' => ['view']]);
            $this->middleware('permission:other_one-delete', ['only' => ['delete']]);
        }
    /** construct */

    /** index */
        public function index(Request $request){
            if($request->ajax()){
                $data = OtherOne::where('status','!=','deleted');
                
                return Datatables::of($data)
                        ->addIndexColumn()
                        ->addColumn('action', function($data){
                            $return = '<div class="btn-group">';

                            // if(auth()->user()->can('other_one-view')){
                                /*$return .= '<a href="'.route('other_one.view', ['id' => base64_encode($data->id)]).'" class="btn btn-default btn-xs">
                                                <i class="fa fa-eye"></i>
                                            </a> &nbsp;';*/
                            // }   
                            
                             if(auth()->user()->can('other_one-edit')){
                                $return .= '<a href="'.route('other_master_1.edit', ['id' => base64_encode($data->id)]).'" class="btn btn-default btn-xs">
                                                <i class="fa fa-pencil"></i>
                                            </a> &nbsp;';
                             }   

                            if (auth()->user()->can('other_one-delete')) {
                                $return .= '<a href="javascript:;" class="btn btn-default btn-xs dropdown-toggle" data-toggle="dropdown">
                                                    <i class="fa fa-bars"></i>
                                                </a> &nbsp;
                                                <ul class="dropdown-menu">
                                                    <li><a class="dropdown-item" href="javascript:;" onclick="change_status(this);" data-status="active" data-id="' . base64_encode($data->id) . '">Active</a></li>
                                                    <li><a class="dropdown-item" href="javascript:;" onclick="change_status(this);" data-status="inactive" data-id="' . base64_encode($data->id) . '">Inactive</a></li>
                                                    <li><a class="dropdown-item" href="javascript:;" onclick="change_status(this);" data-status="deleted" data-id="' . base64_encode($data->id) . '">Deleted</a></li>
                                                </ul>';
                             }

                            $return .= '</div>';

                            return $return;
                        })

                        /*->editColumn('percentage', function ($data) {
                            return $data->percentage."%";
                        })*/
                        ->editColumn('status', function ($data) {
                            if ($data->status == 'active') {
                                return '<span class="badge badge-pill badge-success">Active</span>';
                            } else if ($data->status == 'inactive') {
                                return '<span class="badge badge-pill badge-warning">Inactive</span>';
                            } else if ($data->status == 'deleted') {
                                return '<span class="badge badge-pill badge-danger">Deleted</span>';
                            }
                        })

                        ->rawColumns(['action' ,'percentage' ,'status'])
                        ->filter(function ($query) {
                                if (request()->get('other_one_master', false)) {
                                    $query->where('other_one.name', 'like', "%" . request()->get("other_one_master") . "%");
                                }
                            })
                        ->make(true);
            }
            return view('other_master_1.index');
        }
    /** index */

    /** create */
        public function create(Request $request){
            
            return view('other_master_1.create');
        }
    /** create */

    /** insert */
        public function insert(Request $request){
            if($request->ajax()) { return true; }

            if(!empty($request->name)){
                $crud['name'] = $request->name;
            }else{
                $crud['name'] = '';
            }

            $crud = [
                'name' => $request->name,
                'status' => 'active',
                'created_at' => date('Y-m-d H:i:s'),
                'created_by' => auth()->user()->id,
                
            ];

            $last_id = OtherOne::insertGetId($crud);

            if ($last_id)
            return redirect()->route('other_master_1')->with('success', 'Record inserted successfully');
            else
                return redirect()->back()->with('error', 'Failed to insert record')->withInput();
            
            }
    /** insert */

    /** view */
        /*public function view(Request $request){
            $id = base64_decode($request->id);
            $data = Carvarient::where(['id' => $id])->first();
            
            // return view('other_one.view')->with(['data'=>$data]);

            $Carmodel = Carmodel::where(['status' => 'active'])->get();
            $Colortone = Colortone::where(['status' => 'active'])->get();
            $Fuletype = Fuletype::where(['status' => 'active'])->get();
            $Transmission = Transmission::where(['status' => 'active'])->get();
            $Interiorcolor = Interiorcolor::where(['status' => 'active'])->get();
            $Exteriorcolor = Exteriorcolor::where(['status' => 'active'])->get();
            return view('other_one.view')->with(['data'=>$data,'Carmodel' => $Carmodel ,'Colortone' => $Colortone,'Fuletype'=>$Fuletype,'Transmission' => $Transmission,'Interiorcolor' => $Interiorcolor,'Exteriorcolor' => $Exteriorcolor]);
        }*/
    /** view */
    
    /** edit */
        public function edit(Request $request){
            $id = base64_decode($request->id);
            $data = OtherOne::where(['id' => $id])->first();
           
            return view('other_master_1.edit')->with(['data'=>$data]);
        }
    /** edit */

    /** update */
        public function update(Request $request){
            if($request->ajax()){ return true; }
            $id = $request->id;
            
            if(!empty($request->name)){
                $crud['name'] = $request->name;
            }else{
                $crud['name'] = '';
            }

            $crud = [
                'name' => $request->name,
                'updated_at' => date('Y-m-d H:i:s'),
                'updated_by' => auth()->user()->id
            ];

            DB::enableQueryLog();
            $update = OtherOne::where(['id' => $id])->update($crud);
            

            if ($update)
            return redirect()->route('other_master_1')->with('success', 'Record updated successfully');
            else
                return redirect()->back()->with('error', 'Failed to updated record')->withInput();
            
            }
        
    /** update */

    /** change-status */
        public function change_status(Request $request){
            if (!$request->ajax()) { exit('No direct script access allowed'); }
            $id = base64_decode($request->id);
            
            $data = OtherOne::where(['id' => $id])->first();

            if (!empty($data)) {
                $update = OtherOne::where(['id' => $id])->update(['status' => $request->status, 'updated_at' => date('Y-m-d H:i:s'), 'updated_by' => auth('sanctum')->user()->id]);
                if ($update) {
                    return response()->json(['code' => 200]);
                } else {
                    return response()->json(['code' => 201]);
                }
            } else {
                return response()->json(['code' => 201]);
            }
           
        }
    /** change-status */

     /** Import */
        public function import(Request $request){
            $import = Excel::import(new ImportOtherOne(), $request->file('file'));    
            if($import){
                Excel::store(new ImportOtherOne(), 'OtherOne_'.Date('YmdHis').'.xlsx' ,'excel_import');
                return redirect()->route('other_master_1')->with('sucess' ,'File Imported Sucessfully');
            }
        }
    /** Import */

    /** Export */
        public function export(Request $request){
            $slug = $request->slug;
            $name = 'OtherOne_'.Date('YmdHis').'.xlsx';
    
            try {
                return Excel::download(new ExportOtherOne($slug), $name);
            }catch(\Exception $e){
                return redirect()->back()->with('error', $e->getMessage());
            }
        }
    /** Export */

   
}
